// This file is part of the laron-crypto
//
// Copyright 2023 Ade M Ramdani
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

extern crate core;

mod private_key;
pub use private_key::PrivateKey;

mod public_key;
pub use public_key::PublicKey;

pub mod aes;
pub mod k256;
pub mod totp;

pub mod error {

    /// Error type for this crate.
    #[derive(Debug, PartialEq, Eq)]
    pub enum Error {
        LengthError(String),
        HexError(String),
        DecryptError(String),
        EncryptError(String),
        RecoveryError(String),
        InvalidSignature,
        PrivateKeyError,
        InvalidPublicKey,
    }

    impl std::fmt::Display for Error {
        fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
            match self {
                Error::LengthError(s) => write!(f, "LengthError: {}", s),
                Error::HexError(s) => write!(f, "HexError: {}", s),
                Error::DecryptError(s) => write!(f, "DecryptError: {}", s),
                Error::EncryptError(s) => write!(f, "EncryptError: {}", s),
                Error::RecoveryError(s) => write!(f, "RecoveryError: {}", s),
                Error::InvalidSignature => write!(f, "InvalidSignature"),
                Error::PrivateKeyError => write!(f, "PrivateKeyError"),
                Error::InvalidPublicKey => write!(f, "InvalidPublicKey"),
            }
        }
    }

    impl std::error::Error for Error {}

    impl From<hex::FromHexError> for Error {
        fn from(value: hex::FromHexError) -> Self {
            Error::HexError(value.to_string())
        }
    }

    /// Result type for this crate.
    pub type Result<T> = std::result::Result<T, Error>;
}
